package com.muzhi.zhizhong.entity;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;


@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "同步记录", description = "同步记录")
public class StateZhizhong {

    @ApiModelProperty(value = "订单类型")
    private String type;

    @ApiModelProperty(value = "唯一编码")
    private String pk;

    @ApiModelProperty(value = "审批实例id")
    private String processid;

    @ApiModelProperty(value = "订单编号")
    private String orderid;

    @ApiModelProperty(value = "U8C同步钉钉状态")
    private String state;

    @ApiModelProperty(value = "钉钉审批/签署状态回传")
    private String status;
}
