package com.muzhi.zhizhong.service;

import com.alibaba.fastjson.JSONObject;
import com.muzhi.zhizhong.common.R;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @Author ZhangKan
 * @Data 15:34
 */
public interface DingOaService {
    //获取map集合参数
    String getJsonStr();

    //创建钉钉OA审批：采购订单【传json格式参数】
    R createPuOrder(JSONObject body) throws Exception;

//    //创建钉钉OA审批：采购订单【传jsonStr格式参数】
//    R createPuOrder(String jsonStr) throws Exception;

    //创建钉钉OA审批：销售订单【传json格式参数】
    R createSaOrder(JSONObject body) throws Exception;

//    //创建钉钉OA审批：销售订单【传jsonStr格式参数】
//    R createSaOrder(String jsonStr) throws Exception;

    //附件上传
    R addFile(String download_url,String userid) throws Exception;

    //定时同步钉钉审批单状态至U8C
    R timerStatus();

    //定时同步钉钉审批单合同附件签署状态至U8C
    R timerStatusPDF();
}
